def slope(x1, y1, x2, y2):
    return (y2 - y1) / (x2 - x1)


def y_intercept(x1, y1, x2, y2):
    return (x2 * y1 - x1 * y2) / (x2 - x1)


def line_eqn_from_points(p1, p2):
    # p1, p2 are 2-tuples
    x1, y1 = p1
    x2, y2 = p2

    a = slope(x1, y1, x2, y2)
    b = y_intercept(x1, y1, x2, y2)

    return f"y = {a}x + {b}"


def all_lines_through_points(points):
    num_points = len(points)
    for i in range(num_points):
        for j in range(i + 1, num_points):
            p1 = points[i]
            p2 = points[j]
            try:
                eq = line_eqn_from_points(p1, p2)
                print(f"The equation for the line between {p1} and {p2} is {eq}.")
            except Exception:
                if p1 == p2:
                    print(
                        f"Cannot compute line equation between the identical points {p1} and {p2}."
                    )
                else:
                    print(
                        f"Cannot compute line equation for vertical line between points {p1} and {p2}."
                    )
                continue


if __name__ == "__main__":
    all_lines_through_points(
        [
            (1, 1),
            (-1, 1),
            (1, -1),
            (-1, 1),
        ]
    )

# find place where you can explain _why_ the exception happened, not just _that_ it happened
